{ $Header: $ }
{ Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved. }
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  OpcLabs_EasyOpcClassic_TLB, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var OPCDAClient: _EasyDAClient ;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OPCDAClient.UnsubscribeAllItems ;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OPCDAClient := CoEasyDAClient.Create ;
  OPCDAClient.PullItemChangedQueueCapacity := 1000 ;
  OPCDAClient.SubscribeItem('', 'Matrikon.OPC.Simulation.1', 'Random.UInt1', 50) ;
  OPCDAClient.SubscribeItem('', 'Matrikon.OPC.Simulation.1', 'SomeUnknownItem', 50) ;
  OPCDAClient.SubscribeItem('', 'Matrikon.OPC.Simulation.1', 'Bucket Brigade.UIntqa', 50) ;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
Var i : Integer ;
  EventArgs: _EasyDAItemChangedEventArgs ;
Begin
  Repeat
    EventArgs := OPCDAClient.PullItemChanged(5) ;
    If EventArgs <> nil Then
      If EventArgs.Succeeded Then
        If EventArgs.VTQ.HasValue and EventArgs.VTQ.Quality.IsGood Then
        Begin
          If EventArgs.Arguments.ItemDescriptor.ItemId = 'Random.UInt1' Then
            Edit1.text := EventArgs.VTQ.Value ;
          If EventArgs.Arguments.ItemDescriptor.ItemId = 'SomeUnknownItem' Then
            Edit2.text := 'Edit2 text changed unexpectedly'  ;
          If EventArgs.Arguments.ItemDescriptor.ItemId = 'Bucket Brigade.UIntqa' Then
            Edit3.text := 'Edit3 text changed unexpectedly' ;
        End;
  Until EventArgs = nil ;
End;

end.
